int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    memset(buf, 0, sizeof(buf));

    char in[8] = {'D', 'A', 'T', 'E', 'S', 'S', 'Y'};
    strncpy(in, in_data, sizeof(in) - 1);

    char *p = strchr(in, ' ');
    size_t to_copy = p ? p - in : strlen(in);
    if (size < to_copy) return 0;
    strncpy(out, in, to_copy);

    const char *end_ptr = strchr(in, '\r');
    if (end_ptr)
        end_ptr = strchr(end_ptr + 1, '\r');
    size_t data_size = end_ptr ? (end_ptr - in + 1) : strlen(in) - 1;
    if (data_size >= sizeof(buf)) return 0;

    if (sscanf(buf, "%99s", out) != 1) return 0;

    // The remaining data is terminated by a \r\n
    return 1;
}