int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    const uint8_t *c;
    uint32_t off = 0;
    uint8_t v;
    int i = 0;

    size -= 2; // skip the header
    while (off < size) {
        // parse char
        c = in_data + off;
        if (*c == '\x1e') {
            v = *(c + 1);
            if (v > 31) {
                return -1;
            }
            off += 1;
            if (i == 0) {
                sprintf(buf, "hello %u", v);
            } else {
                sprintf(buf, "hello %s", get_ansi_name(v));
            }
            VLOG_INFO("%s", buf);
        } else if (*c == '\x1f') {
            off += 1;
            if (i == 0) {
                sprintf(buf, "world %u", *(c + 1));
            } else {
                sprintf(buf, "world %s", get_ansi_name(get_ansi_name(*(c + 1))));
            }
            VLOG_INFO("%s", buf);
        } else if (*c == '\x20') {
            v = *(c + 1);
            i = 0;
            while (v > 0x1f) {
                if (*(c + 1 + i) < 32) {
                    i++;
                    v = v - 0x20;
                    break;
                }
                i += 3;
                v = v - 0x20;
            }
            v &= 0x1f;
            if (i > 2) {
                sprintf(buf, "one %u", v);
            } else if (i == 2) {
                sprintf(buf, "two %u", v);
            } else {
                sprintf(buf, "three %u", v);
            }
            VLOG_INFO("%s", buf);
        } else if (*c >= '0' && *c <= '9') {
            v = *c - '0';
            sprintf(buf, "one %u", v);
            VLOG_INFO("%s", buf);
        } else {
            sprintf(buf, "unknown char 0x%02x", *c);
            VLOG_INFO("%s", buf);
        }
        off += strlen(buf);
    }
    return 0;
}