int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    unsigned int pos = 0;

    while (size > 0) {
        char *next = memchr(buf, '\n', size);
        if (next)
            next[0] = '\0';

        int len = lgetxattr(path, buf, pos, out, (next ? next : buf));
        if (len == -1) {
            if (errno == ERANGE) {
                ALOGE("getxattr(%s) value %s is out of range", path, buf);
                return -ERANGE;
            }
            return -errno;
        }

        if (len > 0) {
            pos += len;
            out += len;
            size -= len;
        } else if (len == 0) {
            // Truncate
            break;
        } else {
            // Null
            return -ENOENT;
        }
    }

    return 0;
}