int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    buf[sizeof(buf) - 1] = 0;
    size_t read_size = size;

    /*  Parsing starts here. There are three special cases:
        1. Real data (specify by key) in the first byte,
           if it's the first one, move to data byte and the other
           byte to skip
        2. Synthetic data. If it's not the first byte, move to 0xC2
           and end the parsing. */

    while (read_size > 0) {
        char c;

        if (read_size < 2) {
            BD_DEBUG(DBG_BD_FILE | DBG_CRIT, "Unable to parse\n");
            return 0;
        }

        c = in_data[0];
        if (c == 'D') {
            int i;

            for (i = 1; i < read_size; ++i) {
                c = in_data[i];
                if (c == 0xC2) {
                    break;
                }
            }

            if (i == read_size) {
                BD_DEBUG(DBG_BD_FILE | DBG_CRIT, "Unable to parse\n");
                return 0;
            }

            in_data += i;
            read_size -= i;
        }

        if (c == 0x80) {
            /* end the parsing */
            break;
        }

        in_data++;
        read_size--;
    }

    if (read_size == 0) {
        BD_DEBUG(DBG_BD_FILE, "Empty / no data\n");
        return 0;
    }

    buf[read_size] = 0;

    return sscanf(buf, "%100s", out);
}