int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    // see the header comment
    for (size_t i = 0; i < size; i++)
        buf[i] = in_data[i];
    buf[size] = 0;

    // see if it is http or mime
    if (!strcmp(buf, "http") || !strcmp(buf, "mim")) {
        return parse_http_mime(in_data, size, out);
    }

    // search for content-type
    size_t pos = 0;
    while ((pos = strstr(buf, "\r\nContent-Type:"))) {
        pos += 14;
        size_t new_size = pos + 10;
        out = srenew(char, out, new_size);
        strncpy(out, buf, pos - buf);
        out[new_size - 1] = '\0';
        return pos - buf;
    }

    // fallback
    return 0;
}