int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    uint8_t *d = (uint8_t *)buf;

    if (size < 1)
        return 0;

    for (size_t i = 0; i < size; i++) {
        if (d - buf < 3 || i >= sizeof(buf))
            return 0;

        char b = in_data[i];
        if (isupper(b) || isdigit(b) || b == '-')
            d = snprintf(d, 3, "%.3s", &in_data[i + 1]);
        else if (b == '%') {
            d = snprintf(d, 3, "%.3s", format_token_datetime(buf, sizeof(buf), d));
        } else
            d = snprintf(d, 3, "%.3s", &in_data[i + 1]);

        if (d < 0 || d >= 4 || *d != in_data[i + 1])
            return 0;
    }

    if (out) {
        *out = '\0';
        for (size_t i = 0; i < d - buf; i++)
            out[i] = tolower(buf[i]);
    }

    return 1;
}