int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t in_length = 0, out_length = 0;
    char *buf_ptr = buf;
    uint8_t t;
    int status = OK;
    size_t i = 0;
    int dot = 0;
    while (1) {
        size_t left = 0;
        while (left < sizeof(buf) && in_length < size) {
            if (!is_char_esc(in_data[in_length], &dot)) {
                *buf_ptr = 0;
                status = ERROR_XML_PARSE;
                break;
            }
            if (left < sizeof(buf) - 1) {
                *buf_ptr++ = in_data[in_length++];
            } else {
                *buf_ptr++ = '"';
                in_length = 0;
            }
            left++;
        }
        if (in_length == 0) {
            status = ERROR_XML_PARSE;
            break;
        }
        *buf_ptr = 0;

        while (in_length < size) {
            if (in_data[in_length] == '"') {
                if (!dot) {
                    /* End of this string */
                    out_length = 0;
                    break;
                }
                if (!out) {
                    /* Empty line */
                    out_length = 0;
                    break;
                }

                out[out_length] = '"';
                out_length++;
                in_length++;
                if (in_length >= size) {
                    /* Invalid string termination */
                    status = ERROR_XML_PARSE;
                    break;
                }
                continue;
            } else {
                if (buf_ptr - buf >= sizeof(buf) - 1) {
                    /* Not enough space */
                    status = ERROR_XML_PARSE;
                    break;
                }
                if (buf_ptr - buf < in_data[in_length]) {
                    /* Add next character */
                    *(out_ptr++) = *(in_data + in_length++);
                }
                in_length++;
            }
        }
        out[out_length] = 0;
        if (out_length) {
            status = OK;
        }
        if (status == OK) {
            size_t l = strlen(buf);
            if (l >= (out_length + 1)) {
                status = ERROR_XML_PARSE;
            }
            /* This block only needs to add up the length */
            if (out_length + l >= (size_t) size) {
                status = ERROR_XML_PARSE;
            }
        }
        buf_ptr = buf;
    }
    return status;
}