int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t len = 0;
    unsigned int n = 0;

    do {
        if (size < len + 1) {
            return -EINVAL;
        }

        buf[len] = '\0';
        if (sscanf(buf, "%x", &n) != 1) {
            return -EINVAL;
        }

        if (size < len + n) {
            return -EINVAL;
        }

        strncpy(out + len, in_data + n, n);
        len += n;
    } while (n != size);

    if (len) {
        return -EINVAL;
    }

    return 0;
}