int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    ssize_t n = 0;

    while (size > 0 && n < sizeof(buf) - 1) {
        size_t len = min(sizeof(buf) - 1, size);
        memcpy(buf, in_data + n, len);
        buf[len] = 0;

        char *parsed_str = strstr(buf, ";base64,");
        if (parsed_str == NULL) {
            size_t parsed_size = strcspn(buf, "\r\n");
            if (parsed_size < len) {
                fprintf(stderr, "invalid base64 string detected!\n");
                return 1;
            }

            parsed_str = buf;
            n += parsed_size;
            continue;
        }

        n += parsed_str - buf;
        out[n] = 0;

        size_t base64_len = strcspn(parsed_str, "\r\n");
        out[n] = (char)strtol(parsed_str, NULL, 16);
        parsed_str += base64_len + 1;
        n += base64_len + 1;
        size -= base64_len;
    }

    out[n] = 0;

    return 0;
}