int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t left;
    bool is_gzip = false;
    bool has_plain_text = false;
    char *cpp = out;

    *cpp++ = 0;
    for (size_t i = 0; i < size; i++) {
        char c = in_data[i];

        switch (c) {
        case ' ':
            *cpp++ = '+';
            break;
        case '\n':
            *cpp++ = '+';
            *cpp++ = '+';
            *cpp++ = '+';
            break;
        case '+':
            *cpp++ = '+';
            break;
        case '#':
            *cpp++ = '#';
            break;
        case '-':
            *cpp++ = '-';
            break;
        case '*':
            *cpp++ = '*';
            break;
        case '^':
            *cpp++ = '^';
            break;
        case '~':
            *cpp++ = '~';
            break;
        case '!':
            *cpp++ = '!';
            break;
        case 'b':
            *cpp++ = '\b';
            break;
        case 'f':
            *cpp++ = '\f';
            break;
        case 'n':
            *cpp++ = '\n';
            break;
        case 'r':
            *cpp++ = '\r';
            break;
        case 't':
            *cpp++ = '\t';
            break;
        case '\r':
            *cpp++ = ' ';
            break;
        case '\n':
            *cpp++ = '\n';
            break;
        case '0':
            is_gzip = true;
            break;
        case '1':
            has_plain_text = true;
            *cpp++ = c - '0';
            break;
        case '2':
            is_gzip = true;
            break;
        case '3':
            is_gzip = true;
            break;
        case '4':
            is_gzip = true;
            break;
        case '5':
            is_gzip = true;
            break;
        case '6':
            is_gzip = true;
            break;
        case '7':
            is_gzip = true;
            break;
        case '8':
            is_gzip = true;
            break;
        case '9':
            is_gzip = true;
            break;
        default:
            *cpp++ = c;
            break;
        }
    }
    if (left > 0) {
        *cpp++ = '\0';
    }
    return left;
}