int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    *out = '\0';
    if (size < 1) {
        return EINVAL;
    }
    if (in_data[0] != '{') {
        return EINVAL;
    }

    buf[0] = '\0';
    for (const char *s = &in_data[1]; *s; s++) {
        if (*s == '}') {
            *s = '\0';
            break;
        }
        if (*s == '\\' || *s == 'n' || *s == 't' || *s == 'r') {
            *buf++ = '\\';
        }
        *buf++ = *s;
    }

    while (*buf) {
        if (*buf == 'n') {
            *buf = '\0';
            break;
        }
        if (*buf == 't') {
            *buf = '\0';
            *out = '\t';
            break;
        }
        if (*buf == 'r') {
            *buf = '\0';
            *out = '\r';
            break;
        }
        if (*buf == 'f') {
            *buf = '\0';
            *out = '\f';
            break;
        }
        if (*buf == 'b') {
            *buf = '\0';
            *out = '\b';
            break;
        }
        *out = *buf;
        out++;
        buf++;
    }

    return 0;
}