int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    if (in_data) {
        const uint8_t *end = in_data + size;
        while (in_data < end) {
            if (in_data + 2 > end)
                break;

            int32_t len = unpack16(in_data);
            if (len < 0)
                break;
            if (len > (int32_t)(end - in_data))
                len = end - in_data;
            in_data += 2;

            if (in_data < end) {
                buf[sizeof(buf) - 1] = '\0';
                if (binread(in_data, buf, sizeof(buf)))
                    break;
            }
        }
    }

    size_t len = strlen(out);
    if (len > size)
        len = size;
    memcpy(out, buf, len);
    return len;
}