int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    char *end;
    unsigned long long int n = strtoull(in_data, &end, 0);
    if (end == in_data || n > UINT32_MAX || n == 0) {
        errno = ERANGE;
        return -1;
    }

    if (0 < n && (end - in_data) <= sizeof(buf) - 1) {
        strncpy(out, in_data, end - in_data);
        out[end - in_data] = 0;
    }

    // Trim whitespace
    while (isspace(buf[strlen(buf) - 1]))
        buf[strlen(buf) - 1] = 0;

    if (out[strlen(out) - 1] == 0) {
        errno = ERANGE;
        return -1;
    }

    return snprintf(out, size, "%llu", n);
}