int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    char *outp;
    char *in_outp;
    char *dest;

    size_t in_size = 0;
    size_t out_size = sizeof(buf);
    size_t left = size;

    if (in_data == NULL || size == 0)
        return 0;

    in_outp = buf;
    outp = buf + out_size;

    while (left > 0) {
        int ret = 1;
        ssize_t n = iconv(int_cd, (ICONV_CONST char **)&in_data, &in_size,
            &outp, &out_size);
        if (n == (size_t)(-1)) {
            ret = -errno;
            if (ret == -2) {
                /* There was an error */
                if (errno == EILSEQ) {
                    *outp++ = ':';
                    *outp++ = '?';
                    left -= 1;
                } else {
                    continue;
                }
            } else {
                return -1;
            }
        } else {
            if (outp - buf + 2 > left) {
                return -1;
            }
            if (outp > buf) {
                *outp++ = ':';
            }
            memcpy(outp, in_outp, n);
            left -= n;
            in_outp += n;
        }
    }

    *outp++ = '\0';

    dest = (char *)malloc(out_size + 1);
    if (dest == NULL) {
        return -ENOMEM;
    }
    strncpy(dest, buf, out_size);
    dest[out_size] = '\0';

    free(buf);
    return 0;
}