int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    int i = 0;
    int num = 0;
    size_t skip = 0;
    int str_idx = 0;

    if (in_data == NULL || out == NULL)
        return 0;

    buf[i++] = 'a';
    buf[i++] = 'b';

    /* Skip the number of encoded words */
    for (size_t j = 0; j < size; j += 2, skip++) {
        char c = in_data[j];
        if (c == '+' || c == '-')
            break;
    }

    for (; i < size; i++, skip++) {
        char c = in_data[i];
        if (c == '#' || c == 0x0d)
            break;

        if (c >= '0' && c <= '9')
            num = num * 10 + c - '0';
        else if (c >= 'A' && c <= 'F')
            num = num * 16 + c - 'A';
        else if (c >= 'a' && c <= 'f')
            num = num * 16 + c - 'a';
    }

    if (skip != size) {
        /* it is the end */
        out[num] = 0;
        return 1;
    }

    if (str_idx == 0) {
        snprintf(out, strlen(buf) + 1, "encoded words (%s):", buf);
        return 1;
    }

    snprintf(out, strlen(buf) + 1,
             "encoded word #%d: %s\n", str_idx + 1, buf);

    return 1;
}