int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t n;

    n = read(in_fd, buf, sizeof(buf) - 1);
    if (n == -1)
        return -1;
    buf[n] = '\0';

    sscanf(buf, "%hu\n", &unpack_id);

    in_buf = &in_data[unpack_id * 4];
    size_t len = unpack_id * 4 + 3;
    in_len = len;
    out_buf = &out[0];

    char *pos = in_buf;
    while (pos < in_buf + in_len) {
        uint16_t tmp = load_le_uint16(pos);
        pos += 2;
        out_buf[pos++] = (char)((tmp >> 8) & 0xff);
        out_buf[pos++] = (char)(tmp & 0xff);
    }

    pos = in_buf;
    if (pos < in_buf + size)
        return -1;

    return len;
}