int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    // make sure buf is big enough
    if (size < 1) {
        return NULL;
    }

    for (int i = 0; i < size; i++) {
        buf[i] = in_data[i];
    }

    buf[size] = 0;

    uint8_t tmp_buf[3];
    size_t tmp_buf_size;
    size_t new_size = strlen(buf) + 1;
    if (new_size >= sizeof(tmp_buf)) {
        fprintf(stderr, "Not enough memory to parse requested string: %zu\n", size);
        return NULL;
    }

    // swap until NUL char
    for (size_t i = 0; i < new_size; i++) {
        tmp_buf[i] = buf[i];
    }
    tmp_buf[new_size] = 0;

    // parse buf
    new_size = 0;
    int ret = 0;
    char *tmp_buf_ptr = tmp_buf;
    while ((ret = parse_line(tmp_buf_ptr, new_size, &tmp_buf_size)) != 0) {
        new_size += ret;
    }

    if (new_size > size) {
        fprintf(stderr, "Input buffer length exceeds requested size: %zu, needed %zu\n", size, new_size);
        return NULL;
    }

    ret = 0;
    while ((ret = parse_value(tmp_buf_ptr, tmp_buf_size, out)) != 0) {
        new_size += ret;
    }

    if (new_size > size) {
        fprintf(stderr, "Output buffer length exceeds requested size: %zu, needed %zu\n", size, new_size);
        return NULL;
    }

    // clear the buffer and return
    memset(out, 0, size);

    return out;
}