int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    // clang-format off
    unsigned long out_size = 0;
    for (unsigned int i = 0; i < size; i++) {
        if (in_data[i] == '\n') {
            buf[out_size++] = 0;
            if (out_size > sizeof(buf) - 1) {
                goto parse_error;
            }
        } else {
            buf[out_size++] = in_data[i];
        }
    }
    // clang-format on

    if (out_size == 0) {
        return true;
    }

    buf[out_size] = 0;
    char *s = strstr(buf, "\n");
    if (s) {
        *s = 0;
    }
    size_t found_at = strlen(buf);
    if (s && found_at > 0) {
        // if we don't know how to find the newline we are in the first place
        // i.e we are going to assume that it is an incomplete file and move it
        // to the beginning of the buffer and try again
        memmove(buf, buf + 1, found_at - 1);
    }

    if (buf[0] == '\n') {
        buf[0] = 0;
        if (buf[strlen(buf) - 1] != '\r') {
            strcat(buf, "\r\n");
        }
    } else {
        if (buf[strlen(buf) - 1] != '\r') {
            strcat(buf, "\n\r");
        }
    }

    strcat(buf, out);

    return (size_t)(s ? strlen(s) : 0);

parse_error:
    ALOGD("Parse error in file: %s", buf);
    return 0;
}