#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    uint32_t i, num;
    int num_cols;

    num_cols = 2 + sizeof(uint32_t) + (size - 1) / 3;

    memset(buf, 0, sizeof(buf));

    num = 0;
    for (i = 0; i < size; i++) {
        if (isdigit(in_data[i])) {
            snprintf(buf + num_cols, sizeof(buf) - num_cols, " %c", in_data[i]);
            num += 1;
        } else if (isprint(in_data[i])) {
            snprintf(buf + num_cols, sizeof(buf) - num_cols, " %c", in_data[i]);
            num += 1;
        } else {
            snprintf(buf + num_cols, sizeof(buf) - num_cols, " .");
        }
        num_cols += strlen(buf + num_cols);
    }
    *out = strdup(buf);
    return num;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
