#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    memset(buf, 0, sizeof(buf));

    for (size_t n = 0; n < size; n += 2) {
        switch (in_data[n]) {
            case 0x6b: //   BMH
                if (size - n < 2)
                    goto done;
                out[0] = 'b';
                out[1] = 'h';
                break;
            case 0x73: //   PDH
                if (size - n < 2)
                    goto done;
                out[0] = 'p';
                out[1] = 'h';
                break;
            default:
                goto done;
        }

        out[n + 2] = in_data[n + 1];
    }

    return true;

done:
    if (size)
        memcpy(out, in_data, size);
    return false;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
