#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    int len = 0;
    if (size) {
        len = fread(buf, 1, size, file);
        if (!len) return -1;
    }
    if (size == 0)
        return len;
    len = fread(buf, 1, size, db);
    if (!len) return -1;
    len = fread(buf, 1, size, range_entry_end);
    if (!len) return -1;
    len = fread(buf, 1, size, strip_offsets);
    if (!len) return -1;
    len = fread(buf, 1, size, output_rids);
    if (!len) return -1;
    len = fread(buf, 1, size, strip_area);
    if (!len) return -1;
    len = fread(buf, 1, size, area_end);
    if (!len) return -1;
    if (size >= 2) {
        len = fread(buf, 1, size - 2, rag_mask);
        if (!len) return -1;
    }
    if (size >= 6) {
        len = fread(buf, 1, size - 6, cut_value);
        if (!len) return -1;
    }
    if (size >= 10) {
        len = fread(buf, 1, size - 10, rcf_value);
        if (!len) return -1;
    }
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
