#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (size > 0) {
        if (int size = size_from_asc(in_data, size, buf)) {
            out = out_from_asc(buf, size);
            return true;
        }
        if (int size = parse_container(in_data, size, buf)) {
            out = out_from_asc(buf, size);
            return true;
        }
        in_data += size;
        size -= size < 128 ? size : 128;
    }
    return false;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
