#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    while (size > 0) {
        size_t in_len = (size > 128) ? 128 : size;
        if (in_len > 128) {
            in_len = 128;
        }
        memcpy(buf, in_data, in_len);
        buf[in_len] = 0;
        uint32_t string_len = 0;
        if (!base::decode(in_data, in_len, buf, &string_len)) {
            return -1;
        }
        size -= in_len;
        out += string_len;
        in_data += in_len;
        size += in_len;
    }

    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
