#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (size > 0) {
        if (size < sizeof(buf)) {
            size_t count = sizeof(buf) - size;
            if (count > sizeof(buf) - 1) count = sizeof(buf) - 1;
            memcpy(buf, in_data, size);
            buf[count] = '\0';
            if (!g_strcmp0(buf, "%2X")) {
                return snprintf(out, size, "%s", g_basename(in_data));
            }
        }
        int rv = sscanf(in_data, "%2X", out + size);
        if (rv != 1) return rv;
        if (out[size - 1] == '\n') out[size - 1] = '\0';
        size -= sizeof(buf);
        in_data += sizeof(buf);
    }
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
