#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    // Print header
    int first_line = 1;
    int flevel = 0;
    memset(out, 0, size);

    char buffer[8192];
    memset(buffer, 0, sizeof(buffer));
    memset(buf, 0, sizeof(buf));

    int r = fscanf(in, "%511s%n", buf, &first_line);
    while (r == 1) {
        // Find line
        int s = 0;
        for (; flevel > 0 && buf[s] != '\n'; flevel--) {
            if (buf[s] == '\r')
                break;
            buffer[s++] = buf[s];
        }
        buffer[s] = 0;

        char *item = strstr(buffer, "HTTP/1.");
        if (!item)
            continue;
        item += 4;

        int ss = 0;
        for (; flevel > 0 && buf[ss] != '\n'; flevel--) {
            if (buf[ss] == '\r')
                break;
            buf[ss++] = buf[ss];
        }
        buf[ss] = 0;

        char *value = item + strlen("HTTP/1.");

        int vs = 0;
        for (; flevel > 0 && vs < size; flevel--) {
            if (buf[vs] == '\r')
                break;
            buf[vs++] = buf[vs];
        }
        buf[vs] = 0;

        char *dir = strchr(buf, '=');
        if (dir)
            *dir = 0;

        char *result = parse_field(buf);
        if (!result) {
            if (first_line)
                out[0] = 0;
            else
                strcat(out, "1");
        } else {
            strcpy(out, result);
            free(result);
        }
        r = fscanf(in, "%511s%n", buf, &first_line);
    }
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
