#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t rest = size;
    if (parse_size(size) < 0) {
        if (rest) {
            *out = '\0';
        }
        return -1;
    }
    if (parse_rest_size(rest, buf) < 0) {
        if (rest) {
            *out = '\0';
        }
        return -1;
    }
    strncpy(out, buf, rest);
    out[rest] = '\0';
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
