#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    uint8_t *in;
    uint8_t *p;
    int count = 0;

    if (size < 1)
        return -1;

    in = in_data;
    for (;;) {
        p = memchr(in, 0x20, size);
        if (p == NULL)
            return -1;
        size -= p - in;
        in = p + 1;
        if (in[0] != 0x02 || in[1] != 0x01)
            break;
        ++count;
    }

    snprintf(buf, sizeof(buf), "{");
    strncat(buf, in, count);
    strncat(buf, "}", sizeof(buf) - strlen(buf) - 1);

    strncat(out, buf, sizeof(out) - strlen(out) - 1);

    return count;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
