#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    int r;
    memset(buf, 0, sizeof(buf));

    r = get_int_r(in_data, size, "row number");
    if (r) {
        *out = ' ';
        memcpy(out + 1, in_data, size);
        r = end_string_r(buf);
        if (r < 0)
            return r;
    } else {
        r = end_string_r("row number");
        if (r < 0)
            return r;
    }

    r = get_int_r(in_data, size, "column number");
    if (r) {
        *out = ' ';
        memcpy(out + 1, in_data, size);
        r = end_string_r(buf);
        if (r < 0)
            return r;
    } else {
        r = end_string_r("column number");
        if (r < 0)
            return r;
    }

    if (sscanf(buf, "%d,%d", &r, &c) < 2)
        return -1;

    *out = 0;
    return r;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
