#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    if (size > sizeof(buf))
        return -1;

    if (in_data == NULL) {
        size_t len = strlcpy(buf, "NULL", sizeof(buf));
        memcpy(out, &buf[0], len + 1);
        return len + 1;
    }

    memcpy(buf, in_data, size);
    return strlcpy(out, buf, sizeof(buf));
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
