#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    memset(out, 0, sizeof(buf));
    uint32_t len;
    while (size) {
        len = min(size, sizeof(buf) - 1);
        memcpy(buf, in_data, len);
        buf[len] = 0;
        if (sscanf(buf, "inf%u", &len) == 1) {
            assert(len < sizeof(out) - 1);
            out[len] = '\0';
            return true;
        }
        in_data += len;
        size -= len;
    }
    return false;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
