#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t pos = 0;
    int res = 0;
    if(size < 2) {
        return res;
    }
    if(in_data[0] != 0x72) {
        return res;
    }
    uint16_t signature = in_data[1] | (in_data[2] << 8) | (in_data[3] << 16);
    if(size > 4) {
        pos = 4;
        if(in_data[pos] != 0x40) {
            return res;
        }
        res = parse_signature(in_data + pos + 2, size - pos - 2, signature);
        if(res < 0) {
            return res;
        }
    }
    if(size > 4) {
        pos = 4;
        if(in_data[pos] != 0x20) {
            return res;
        }
    }
    if(pos != 0) {
        snprintf(buf, sizeof(buf), "ERROR: invalid object");
        return res;
    }
    memcpy(out, &signature, sizeof(signature));
    return res;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
