#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t offset;

    for (offset = 0; offset < size; offset++) {
        size_t cur_pos;
        if (offset == 0)
            cur_pos = strlen(in_data);
        else
            cur_pos = (size_t)offset;

        if (cur_pos > (size - offset) && strlen(in_data) > offset + 1) {
            strncpy(buf, in_data, offset);
            buf[offset] = 0;
            strncpy(out, buf, strlen(buf));
            out[strlen(buf)] = 0;
        } else {
            strncpy(buf, in_data + offset, cur_pos);
            buf[cur_pos] = 0;
            strncpy(out, buf, strlen(buf));
            out[strlen(buf)] = 0;
        }
    }

    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
