#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    for (size_t i = 0; i < size; i++) {
        uint8_t val;
        uint32_t val32;
        if (in_data[i] & 0x80)
            val = in_data[i] & 0x7f;
        else
            val = 0;
        if (val <= 33) {
            sprintf(buf, "%u ", val);
        } else {
            if (val <= 126)
                sprintf(buf, "&#%u ", val);
            else
                sprintf(buf, "%u+%u ", val, val);
        }
        if (strcmp(buf, out) == 0)
            return 0;
        out[i] = 0;
    }
    return -1;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
