#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    while (size > 0 && isspace(*in_data))
        in_data++;

    while (size > 0 && !isspace(*in_data) && *in_data != '\r' && *in_data != '\n') {
        size--;
        if (*in_data == 0) {
            return -1;
        }
        buf[size] = *in_data;
        in_data++;
    }

    buf[size] = '\0';
    out[0] = '\0';
    for (size_t i = 0; i < size; i++) {
        if (buf[i] == '\r' && !(buf[i + 1] == '\n'))
            buf[i] = '\n';
        if (buf[i] == '\n') {
            out[i + 1] = '\0';
            break;
        }
    }
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
