#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (size > 0) {
        if (in_data[0] == 'P' && in_data[1] == 'A') {
            // PrintProtos will fail for protos up to 15
            // we use -1 to indicate a non-protoport choice
            fprintf(stdout,
                    "Protos: %08x %d", (uint32_t)in_data[2], (int)(in_data[2] - 1));
            if (in_data[3] == '\0') {
                fputs(dev_gen_uuid_bin, stdout);
            } else {
                /* We can only print device info for various (non-UUID) UUID types
                 * however, since some types of OS have the older format the
                 * device number is used for the UUID instead.
                 *
                 * See dmesg(7).
                 */
                char hex_uuid[64];
                uint32_t uuid =
                    sg_get_unaligned_be32(in_data + 4) & 0xffffff;
                sg_get_big_sense_str(in_data + 6, sizeof(buf), hex_uuid, true,
                                     sizeof(hex_uuid), true, &uuid_type);
                hex2stdout(hex_uuid, sizeof(hex_uuid), stdout);
            }
            return 4;
        }
        size -= (in_data[0] + 1);
        in_data += (in_data[0] + 1);
    }
    return -1;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
