#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t pos = 0;
    while (pos < size) {
        size_t to_read = pos < 128 ? (size_t)pos : 128;
        size_t count = sreadn(in_data, to_read, buf);
        if (count == (size_t)-1) {
            return -1;
        }
        size_t len = strlen(buf);
        if (pos + len > size) {
            break;
        }
        if (count + len < size) {
            memcpy(out + pos, buf, len);
            pos += len;
        } else {
            memcpy(out + pos, buf, to_read);
            pos += to_read;
        }
    }
    *out = 0;
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
