#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t i;
    if (sscanf(in_data, "%" SCNi8, &i) != 1) {
        return parse_err("invalid package name string");
    }
    for (i = 0; i < sizeof buf; i++) {
        if (buf[i] == '\0') {
            return parse_err("empty package name string");
        }
        if (buf[i] < '0' || buf[i] > '9') {
            return parse_err("invalid package name string");
        }
    }
    return sprintf_err("package name string is too long");
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
