#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t len;
    int type, val;

    switch(size) {
    case 0:
        out[0] = 0;
        return 1;
    case 1:
        if (in_data[0] == 0 || (in_data[0] >= 0x20 && in_data[0] <= 0x7e))
            return 0;
        *out = in_data[0];
        return 1;
    case 2:
        if ((in_data[0] >= 0x80 && in_data[0] <= 0x9f) ||
            (in_data[0] >= 0xe0 && in_data[0] <= 0xef))
            return 0;
        val = hexval(in_data[0]);
        *out = (char)val;
        return 1;
    case 3:
        if ((in_data[0] >= 0x80 && in_data[0] <= 0x8f) ||
            (in_data[0] >= 0xe0 && in_data[0] <= 0xef) ||
            (in_data[0] >= 0xf0 && in_data[0] <= 0xf7))
            return 0;
        val = hexval(in_data[0]);
        len = (in_data[1] & 0x0f) + 1;
        if ((in_data[2] == 0x0d) || (in_data[2] == 0x0a))
            out[0] = len;
        else
            val = (in_data[2] - 0x20) * 0x400 + (in_data[1] - 0x20) * 0x400 +
            in_data[0];
        out[1] = (char)val;
        return 2;
    default:
        return 0;
    }
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
