#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    while (true) {
        if (size < 1)
            return false;

        size_t n = static_cast<size_t>(min(sizeof(buf), size));
        size_t r = in_data[0];

        if (r == 0 && n == 0)
            break;

        if (n > 0) {
            memcpy(buf, in_data, n);
            buf[n] = 0;
            r = sscanf(buf, "%1023s", out);
        }

        if (r != 1 || *out != 0)
            return false;

        in_data += n + 1;
        size -= n + 1;
    }

    return true;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
