#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    int i = 0;
    int read = 0;

    buf[0] = 0;
    if (size < 2) {
        log_message(LOG_LEVEL_ERROR, "Unable to parse hex data");
        return -1;
    }

    if (in_data[0] == '+') {
        in_data++;
        size--;
    }

    while (size > 0) {
        if (in_data[0] == ' ') {
            read++;
            buf[i++] = in_data[read++];
            size--;
            continue;
        }
        if (in_data[0] == 0) {
            in_data++;
            size--;
            continue;
        }
        if (in_data[0] == '\r') {
            in_data++;
            size--;
            continue;
        }
        if (in_data[0] == '\n') {
            break;
        }
        if (read + 1 > sizeof(buf) - 1) {
            log_message(LOG_LEVEL_ERROR, "Too long hex data, truncating");
            return -1;
        }
        snprintf(buf + read, sizeof(buf) - read - 1, "%02x", in_data[read]);
        read += 1;
        size -= 1;
    }

    if (buf[0] == 0 && i > 0) {
        log_message(LOG_LEVEL_ERROR, "Bad hex data: %s", buf);
        return -1;
    }

    strcpy(out, buf);
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
