#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    int status = 0;
    size_t read;

    size_t out_size = sizeof(buf);
    int res = read(STDIN_FILENO, buf, size);
    if (res < 0) {
        fprintf(stderr, "Failed to read stdin: %s\n", strerror(errno));
        return 1;
    }
    if (res == 0) {
        fprintf(stderr, "Unexpected EOF while reading stdin\n");
        return 1;
    }

    read = res;

    if (out) {
        res = ::read(STDOUT_FILENO, out, out_size);
        if (res < 0) {
            fprintf(stderr, "Failed to write to stdout: %s\n", strerror(errno));
            return 1;
        }
        if (res == 0) {
            fprintf(stderr, "Unexpected EOF while writing to stdout\n");
            return 1;
        }
        out_size -= res;
    }

    char c;
    while (read < size) {
        c = in_data[read++];
        if (c == '\n') {
            if (out) {
                res = ::write(STDOUT_FILENO, out, out_size);
                if (res < 0) {
                    fprintf(stderr, "Failed to write to stdout: %s\n", strerror(errno));
                    return 1;
                }
            }
            if (in_data[0] == '\n') {
                read--;
            }
            break;
        }
        if (c != '\r') {
            out = buf;
            if (out) {
                res = ::write(STDOUT_FILENO, out, out_size);
                if (res < 0) {
                    fprintf(stderr, "Failed to write to stdout: %s\n", strerror(errno));
                    return 1;
                }
            }
        }
    }
    return status;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
