#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    char *out_ptr = out;

    in_data += 2;
    size -= 2;
    while (size > 0) {
        size_t in_size = size > sizeof(buf) ? sizeof(buf) : size;
        if (in_size > sizeof(buf))
            in_size = sizeof(buf);
        memcpy(buf, in_data, in_size);
        buf[in_size] = 0;

        int ret = parse_line(buf, in_size, out_ptr);
        if (ret)
            return ret;
        in_data += in_size + 1;
        size -= in_size + 1;
        out_ptr += ret;
    }

    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
