#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (size > 0) {
        int result = decode(in_data, size, buf);
        if (result > 0) {
            if (out) {
                out += result;
                out[-1] = 0;
            }
            return result;
        }
        if (result < 0) {
            break;
        }
        if (!out) {
            return result;
        }
        strcpy(out, buf);
        size -= result + 1;
        out += result;
    }
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
