#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t length;

    // read the data
    if (size < 8) {
        return -EINVAL;
    }

    memcpy(buf, in_data, 8);
    length = 8;
    memcpy(out, buf, length);

    if (memcmp(buf, "\x01\x01\x01", 3) == 0) {
        // UTF-8 character set
        return 2;
    } else if (memcmp(buf, "\xff\xfe", 2) == 0) {
        // UTF-16LE character set
        return 4;
    } else if (memcmp(buf, "\xff\xfe\xff", 3) == 0) {
        // UTF-16BE character set
        return 5;
    } else {
        return -EINVAL;
    }
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
