#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    char *end;
    int r = 0;

    if (size > (size_t) sizeof(buf) - 1) {
        out = buf;
        size = sizeof(buf) - 1;
    }

    end = out + size;
    while (end > out && *in_data) {
        size_t b = 0;
        if (in_data[0] == '"' && in_data[in_data[1]] == '"') {
            in_data += 2;
            b = 1;
            end -= 2;
            if (end > out && *in_data == '"') {
                in_data++;
                b = 1;
                end--;
            }
        }
        if (in_data[0] == ' ') {
            *end = '\0';
            return parse_chars(in_data, size - b, out, b, " ");
        }
        b = parse_bytes(in_data, end, buf, sizeof(buf), " ");
        r = write_utf8(out, out_buffer, out_pos, buf, b);
        if (r == -1) {
            if (r == -2) {
                break;
            }
            out = buf;
            size = sizeof(buf) - 1;
            out_pos = 0;
            if (out_buff_size == 0) {
                out_buff_size = size;
            }
        }
        in_data += b;
        if (out_pos + b > out_buff_size) {
            out_buff_size += b;
            out_buffer = realloc(out_buffer, out_buff_size);
            out_pos = 0;
            out_buffer[out_pos++] = '\0';
        }
    }
    out[r] = '\0';
    return r;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
