#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t remaining = size;
    char *pbuf = out;
    const char *s;
    if (!remaining || (in_data[0] & 0x80) == 0)
        return 0;
    s = in_data;
    while (remaining) {
        int r = recv(g.fd, buf, sizeof(buf), 0);
        if (r == -1) {
            if (errno == EINTR)
                continue;
            else
                return -1;
        }
        if (r == 0)
            return 0;
        if (r > 0) {
            remaining -= r;
            pbuf += r;
            if (pbuf > out + size)
                return 0;
        } else {
            *pbuf = 0;
            if (remaining == 1)
                break;
            return 0;
        }
    }
    return 0;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
