#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    char *end;
    unsigned long long int n = strtoull(in_data, &end, 0);
    if (end == in_data || n > UINT32_MAX || n == 0) {
        errno = ERANGE;
        return -1;
    }

    if (0 < n && (end - in_data) <= sizeof(buf) - 1) {
        strncpy(out, in_data, end - in_data);
        out[end - in_data] = 0;
    }

    // Trim whitespace
    while (isspace(buf[strlen(buf) - 1]))
        buf[strlen(buf) - 1] = 0;

    if (out[strlen(out) - 1] == 0) {
        errno = ERANGE;
        return -1;
    }

    return snprintf(out, size, "%llu", n);
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
