#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t out_size;

    // find MIME header
    out_size = g_mime_parser_step(parser, in_data, size, buf, sizeof(buf));
    if (out_size == 0)
        return -1;

    // send our buffer
    g_mime_parser_write(parser, buf, out_size);

    // parse the new data
    out_size = g_mime_parser_step(parser, in_data, size, NULL, 0);
    if (out_size == 0) {
        g_mime_parser_reset(parser);
        return -1;
    }

    // reset
    g_mime_parser_reset(parser);

    // cleanup
    g_mime_parser_reset(parser);

    // transform to ascii
    return g_mime_converter_base64_decode_step(converter, buf, size, out, out_size);
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
