#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    int i = 0;
    size_t j;
    while (i < size && isprint(in_data[i])) {
        out[i] = in_data[i];
        i++;
    }
    out[i] = '\0';
    for (j = 0; j < i && isprint(out[j]); j++)
        ;
    while (i < j && isprint(out[i]))
        i++;
    while (isprint(out[i]))
        i++;
    if (j != i && out[i] == '\\') {
        //
        // The backslash char was not followed by a space.
        //
        out[i] = '\0';
        for (j = 0; j < i && isprint(out[j]); j++)
            ;
        while (i < j && isprint(out[i]))
            i++;
    }
    while (i < j && isprint(out[i]))
        i++;
    return i;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
