#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <glib.h>

int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    bool ret = false;

    if (size > sizeof(buf)) {
        ret = true;
        return ret;
    }

    while (size > 0) {
        size_t s = snprintf(buf, sizeof(buf), "%s\n", in_data);

        if (s > 0) {
            int fd = adb_open(buf, O_RDONLY);
            if (fd >= 0) {
                ret = true;
                adb_close(fd);
            }
        }
        if (!ret) {
            break;
        }

        in_data += s + 1;
        size -= s + 1;
    }

    memcpy(out, buf, s);
    out[s] = '\0';
    return ret;
}
int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
    char *buf = malloc(Size);
    int n = parse(Data, Size, buf);
    free(buf);
    return n;
}
